Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -1728,60 +3298,60 @@
 
     /*************************************************************************
-                  NONLINEAR BOUND CONSTRAINED OPTIMIZATION USING
-                          MODIFIED ACTIVE SET ALGORITHM
-                       WILLIAM W. HAGER AND HONGCHAO ZHANG
-
-    DESCRIPTION:
-    The  subroutine  minimizes  function  F(x)  of  N  arguments  with   bound
-    constraints: BndL[i] <= x[i] <= BndU[i]
-
-    This method is  globally  convergent  as  long  as  grad(f)  is  Lipschitz
-    continuous on a level set: L = { x : f(x)<=f(x0) }.
-
-
-    REQUIREMENTS:
-    Algorithm will request following information during its operation:
-    * function value F and its gradient G (simultaneously) at given point X
-
-
-    USAGE:
-    1. User initializes algorithm state with MinASACreate() call
-    2. User tunes solver parameters with MinASASetCond() MinASASetStpMax() and
-       other functions
-    3. User calls MinASAOptimize() function which takes algorithm  state   and
-       pointer (delegate, etc.) to callback function which calculates F/G.
-    4. User calls MinASAResults() to get solution
-    5. Optionally, user may call MinASARestartFrom() to solve another  problem
-       with same N but another starting point and/or another function.
-       MinASARestartFrom() allows to reuse already initialized structure.
-
-
-    INPUT PARAMETERS:
-        N       -   problem dimension, N>0:
-                    * if given, only leading N elements of X are used
-                    * if not given, automatically determined from sizes of
-                      X/BndL/BndU.
-        X       -   starting point, array[0..N-1].
-        BndL    -   lower bounds, array[0..N-1].
-                    all elements MUST be specified,  i.e.  all  variables  are
-                    bounded. However, if some (all) variables  are  unbounded,
-                    you may specify very small number as bound: -1000,  -1.0E6
-                    or -1.0E300, or something like that.
-        BndU    -   upper bounds, array[0..N-1].
-                    all elements MUST be specified,  i.e.  all  variables  are
-                    bounded. However, if some (all) variables  are  unbounded,
-                    you may specify very large number as bound: +1000,  +1.0E6
-                    or +1.0E300, or something like that.
-
-    OUTPUT PARAMETERS:
-        State   -   structure stores algorithm state
-
-    NOTES:
-
-    1. you may tune stopping conditions with MinASASetCond() function
-    2. if target function contains exp() or other fast growing functions,  and
-       optimization algorithm makes too large steps which leads  to  overflow,
-       use MinASASetStpMax() function to bound algorithm's steps.
-    3. this function does NOT support infinite/NaN values in X, BndL, BndU.
+    Obsolete function, use MinLBFGSSetPrecDefault() instead.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgssetdefaultpreconditioner(minlbfgsstate state)
+    {
+
+        mincomp.minlbfgssetdefaultpreconditioner(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Obsolete function, use MinLBFGSSetCholeskyPreconditioner() instead.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgssetcholeskypreconditioner(minlbfgsstate state, double[,] p, bool isupper)
+    {
+
+        mincomp.minlbfgssetcholeskypreconditioner(state.innerobj, p, isupper);
+        return;
+    }
+
+    /*************************************************************************
+    This is obsolete function which was used by previous version of the  BLEIC
+    optimizer. It does nothing in the current version of BLEIC.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetbarrierwidth(minbleicstate state, double mu)
+    {
+
+        mincomp.minbleicsetbarrierwidth(state.innerobj, mu);
+        return;
+    }
+
+    /*************************************************************************
+    This is obsolete function which was used by previous version of the  BLEIC
+    optimizer. It does nothing in the current version of BLEIC.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetbarrierdecay(minbleicstate state, double mudecay)
+    {
+
+        mincomp.minbleicsetbarrierdecay(state.innerobj, mudecay);
+        return;
+    }
+
+    /*************************************************************************
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1791,5 +3361,5 @@
     {
         state = new minasastate();
-        minasa.minasacreate(n, x, bndl, bndu, state.innerobj);
+        mincomp.minasacreate(n, x, bndl, bndu, state.innerobj);
         return;
     }
@@ -1801,5 +3371,5 @@
         state = new minasastate();
         n = ap.len(x);
-        minasa.minasacreate(n, x, bndl, bndu, state.innerobj);
+        mincomp.minasacreate(n, x, bndl, bndu, state.innerobj);
 
         return;
@@ -1807,24 +3377,6 @@
 
     /*************************************************************************
-    This function sets stopping conditions for the ASA optimization algorithm.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        EpsG    -   >=0
-                    The  subroutine  finishes  its  work   if   the  condition
-                    ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                    G - gradient.
-        EpsF    -   >=0
-                    The  subroutine  finishes  its work if on k+1-th iteration
-                    the  condition  |F(k+1)-F(k)|<=EpsF*max{|F(k)|,|F(k+1)|,1}
-                    is satisfied.
-        EpsX    -   >=0
-                    The subroutine finishes its work if  on  k+1-th  iteration
-                    the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
-        MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
-                    iterations is unlimited.
-
-    Passing EpsG=0, EpsF=0, EpsX=0 and MaxIts=0 (simultaneously) will lead to
-    automatic stopping criterion selection (small EpsX).
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1834,17 +3386,11 @@
     {
 
-        minasa.minasasetcond(state.innerobj, epsg, epsf, epsx, maxits);
+        mincomp.minasasetcond(state.innerobj, epsg, epsf, epsx, maxits);
         return;
     }
 
     /*************************************************************************
-    This function turns on/off reporting.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        NeedXRep-   whether iteration reports are needed or not
-
-    If NeedXRep is True, algorithm will call rep() callback function if  it is
-    provided to MinASAOptimize().
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1854,17 +3400,11 @@
     {
 
-        minasa.minasasetxrep(state.innerobj, needxrep);
+        mincomp.minasasetxrep(state.innerobj, needxrep);
         return;
     }
 
     /*************************************************************************
-    This function sets optimization algorithm.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm stat
-        UAType  -   algorithm type:
-                    * -1    automatic selection of the best algorithm
-                    * 0     DY (Dai and Yuan) algorithm
-                    * 1     Hybrid DY-HS algorithm
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1874,21 +3414,11 @@
     {
 
-        minasa.minasasetalgorithm(state.innerobj, algotype);
+        mincomp.minasasetalgorithm(state.innerobj, algotype);
         return;
     }
 
     /*************************************************************************
-    This function sets maximum step length
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        StpMax  -   maximum step length, >=0. Set StpMax to 0.0,  if you don't
-                    want to limit step length (zero by default).
-
-    Use this subroutine when you optimize target function which contains exp()
-    or  other  fast  growing  functions,  and optimization algorithm makes too
-    large  steps  which  leads  to overflow. This function allows us to reject
-    steps  that  are  too  large  (and  therefore  expose  us  to the possible
-    overflow) without actually calculating function value at the x+stp*d.
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1898,5 +3428,5 @@
     {
 
-        minasa.minasasetstpmax(state.innerobj, stpmax);
+        mincomp.minasasetstpmax(state.innerobj, stpmax);
         return;
     }
@@ -1910,5 +3440,5 @@
     {
 
-        bool result = minasa.minasaiteration(state.innerobj);
+        bool result = mincomp.minasaiteration(state.innerobj);
         return result;
     }
@@ -1953,26 +3483,6 @@
 
     /*************************************************************************
-    ASA results
-
-    INPUT PARAMETERS:
-        State   -   algorithm state
-
-    OUTPUT PARAMETERS:
-        X       -   array[0..N-1], solution
-        Rep     -   optimization report:
-                    * Rep.TerminationType completetion code:
-                        * -2    rounding errors prevent further improvement.
-                                X contains best point found.
-                        * -1    incorrect parameters were specified
-                        *  1    relative function improvement is no more than
-                                EpsF.
-                        *  2    relative step is no more than EpsX.
-                        *  4    gradient norm is no more than EpsG
-                        *  5    MaxIts steps was taken
-                        *  7    stopping conditions are too stringent,
-                                further improvement is impossible
-                    * Rep.IterationsCount contains iterations count
-                    * NFEV countains number of function calculations
-                    * ActiveConstraints contains number of active constraints
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -1983,15 +3493,11 @@
         x = new double[0];
         rep = new minasareport();
-        minasa.minasaresults(state.innerobj, ref x, rep.innerobj);
+        mincomp.minasaresults(state.innerobj, ref x, rep.innerobj);
         return;
     }
 
     /*************************************************************************
-    ASA results
-
-    Buffered implementation of MinASAResults() which uses pre-allocated buffer
-    to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
-    intended to be used in the inner cycles of performance critical algorithms
-    where array reallocation penalty is too large to be ignored.
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -2001,20 +3507,11 @@
     {
 
-        minasa.minasaresultsbuf(state.innerobj, ref x, rep.innerobj);
+        mincomp.minasaresultsbuf(state.innerobj, ref x, rep.innerobj);
         return;
     }
 
     /*************************************************************************
-    This  subroutine  restarts  CG  algorithm from new point. All optimization
-    parameters are left unchanged.
-
-    This  function  allows  to  solve multiple  optimization  problems  (which
-    must have same number of dimensions) without object reallocation penalty.
-
-    INPUT PARAMETERS:
-        State   -   structure previously allocated with MinCGCreate call.
-        X       -   new starting point.
-        BndL    -   new lower bounds
-        BndU    -   new upper bounds
+    Obsolete optimization algorithm.
+    Was replaced by MinBLEIC subpackage.
 
       -- ALGLIB --
@@ -2024,5 +3521,5 @@
     {
 
-        minasa.minasarestartfrom(state.innerobj, x, bndl, bndu);
+        mincomp.minasarestartfrom(state.innerobj, x, bndl, bndu);
         return;
     }
